;RM11   OD ELNOVY PRO PRAKTICKOU ELEKTRONIKU 2024
;KRYSTAL 10MHz....NUTNO PRO CASOVOU ZAKLADNU !!!!!!!!! 

$MOD52

	SH1		EQU		P0.0		;SCHOD 1
	SH2		EQU		P0.1		;SCHOD 2
	SH3		EQU		P0.2		;SCHOD 3
	SH4		EQU		P0.3		;SCHOD 4
	SH5		EQU		P0.4		;SCHOD 5
	SH6		EQU		P0.5		;SCHOD 6
	SH7		EQU		P0.6		;SCHOD 7
	SH8		EQU		P0.7		;SCHOD 8

	SH9		EQU		P2.7		;SCHOD 9
	SH10		EQU		P2.6		;SCHOD 10
	SH11		EQU		P2.5		;SCHOD 11
	SH12		EQU		P2.4		;SCHOD 12
	SH13		EQU		P2.3		;SCHOD 13
	SH14		EQU		P2.2		;SCHOD 14
	SH15		EQU		P2.1		;SCHOD 15
	SH16		EQU		P2.0		;SCHOD 16

;-------------------------------------------SCHODY---------------------------

	FOTONKA	EQU		P1.4		;OSVETLENI MERENI VSTUP

;-----------------------------------------ULTRAZVUK----------------------------
	TRIG1		EQU		P1.0
	OUT1		EQU		P1.1
	TRIG2		EQU		P1.2
	OUT2		EQU		P1.3
;----------------------------------------DIP PREPINAC -------------------------------
	DIP1		EQU		P3.0		;VZDALENOST REAKCE 0-70	
	DIP2		EQU		P3.1		;VZDALENOST REAKCE 0-80	
	DIP3		EQU		P3.2		;VZDALENOST REAKCE 0-90	
	DIP4		EQU		P3.3		;VZDALENOST REAKCE 0-100
							;		 JINAK 0-110	

	DIP5		EQU		P3.4		;PROVOZ I VE DNE = FOTONKA JE VYRAZENA 				
	DIP6		EQU		P3.5		;PRENOS Z FOTONKY NA SH3 FCE PRO NASTAVENI FOTONKY			
	DIP7		EQU		P3.6		;RYCHLOST VLNY 5SEC	JINE CASY NELZE DOCILITI		
	DIP8		EQU		P3.7		;RYCHLOST VLNY 7SEC	JINE CASY NELZE DOCILITI		
							;JINAK RYCHLOST VLNY 3SEC	JINE CASY NELZE DOCILITI

;TIMER 1 = 5SEC NAPEVNO ....PO TUTO DOBU LZE ZHASNOUTI VLNU PROTEJSIM CIDLEM
;PAK NASLEDUJE TIMER 2 = 2 MINUTY NAPEVNO PO ODCASOVANI DOJDE KE ZHASNUTI PLYNULEMU DO 15 SEC.

ORG 60H 
;===================================VSTUPNI PODMINKY  =============================================
	MOV P0,#000H	;SCHODY
	MOV P2,#000H	;SCHODY

	MOV P3,#0FFH	;PREPINAC DIP8

	SETB	OUT1		;VSTUPY
	SETB 	OUT2
	
	CLR TRIG1		;VYSTUPY
	CLR TRIG2

	MOV 030H,#000H
	MOV 031H,#000H
	MOV 032H,#000H
	MOV 033H,#000H

	MOV R0,#000H	; CITAC NAHORU------------------------------------------
	MOV R1,#000H	; CITAC NAHORU------------------------------------------

;----------------------------------HLAVNI PROGRAM ------------------------------------------------
	;LCALL ZHASINANI

	MOV 052H,#080H	;REGISTR PREDMETU PRISLUSNYCH CIDEL
	
	LCALL T100MS
	LCALL UC2			;SPUSTENI OD CIDLA2

	LCALL T100MS
	LCALL UC1			;SPUSTENI OD CIDLA1
		
	LJMP H10	;>>>>>>>>>>>>>>>>>>>>>>>>>>>>> H10
	;LJMP TESTCIDLA2
	;LCALL INTR 	;VLNA VPRAVO 
	;LCALL ZINTR	;ZHASENI VPRAVO

	;LCALL LINTL	;VLNA VLEVO
	;LCALL LZINTL	;ZHASENI VLEVO
;----------------------------------------------STARA VLNA SKOKOVA NEEE INTENZITNI ------------------------------
H3:	LCALL VLNAVPRAVO
	LCALL T1S
	LCALL NVLNAVPRAVO
	LCALL T1S

	LCALL VLNAVLEVO
	LCALL T1S
	LCALL NVLNAVLEVO
	LCALL T1S

	LJMP H3
;===============================================================================================================================

H10:	JNB DIP5,H8			;I DENNI PROVOZ = VYRAZENI FOTONKY DIP5=ON
;----------------------------------------------------------------------------
	JB DIP6,H9			;NASTAVENI FOTONKY NA SERVIZU DIP6=ON
	LJMP H200			;NASTAVENI FOTONKY NA SERVIZU
;----------------------------------------------------------------------------
H9:	JB FOTONKA,H10		;TEST OSVETLENI FOTONKOU = 5V = MOC SVETLA 
;----------------------------------------------------------------------------
H8:	LCALL T100MS
	LCALL UC2			;SPUSTENI OD CIDLA2
	MOV A,052H
	CJNE A,#000H,H11		;PREDMET JE PRITOMEN
;------------------------------
LCALL T100MS
	LCALL UC1			;SPUSTENI OD CIDLA1
	MOV A,052H
	CJNE A,#000H,H21		;PREDMET JE PRITOMEN
;------------------------------------------------------------

	LJMP H10
;=================================================================================================================================
;===========================================INTEZITNI VLNA VPRAVO ================================================================
;=================================================================================================================================

H11: LCALL INTR 	;VLNA VPRAVO  				;VLNAVPRAVO	
	LJMP H14

H13: LCALL ZINTR	;ZHASENI VPRAVO 				;NVLNAVPRAVO	
	LJMP H10
;------------------------------------TIMER 1 = 50 x 0,1 SEC = 5 SEC --------------------------
H14:	MOV R0,#100D		;100 x 0,1SEC=TIMER2=10SEC
H15:	LCALL T100MS
	LCALL UC1
	MOV A,052H
	CJNE A,#000H,H13  	;PREDMET JE PRITOMEN
	DJNZ R0,H15
;-----------------------------------TIMER 2 = 250 x 4 x 0,1 SEC = 2 MINUTY CCA I SE ZHASNUTIM --------------------------
	MOV R0,#250D
H16:	LCALL T100MS
	;LCALL UC1
	;MOV A,052H
	;CJNE A,#000H,H13  	;PREDMET JE PRITOMEN
	DJNZ R0,H16
;-----------------------------------
	MOV R0,#250D
H17:	LCALL T100MS
	;LCALL UC1
	;MOV A,052H
	;CJNE A,#000H,H13  	;PREDMET JE PRITOMEN
	DJNZ R0,H17
;-----------------------------------
	MOV R0,#250D
H18:	LCALL T100MS
	;LCALL UC1
	;MOV A,052H
	;CJNE A,#000H,H13  	;PREDMET JE PRITOMEN
	DJNZ R0,H18
;-----------------------------------
	MOV R0,#250D
H19:	LCALL T100MS
	;LCALL UC1
	;MOV A,052H
	;CJNE A,#000H,H13  	;PREDMET JE PRITOMEN
	DJNZ R0,H19
;-----------------------------------
	LCALL ZHASINANI		; ZHASNUTI ZA 15 SEC JAKO V KINE 
	LJMP H10

;--------------------------------------------------------------------------------------------------------------------------------------
;---------------------------------------------------INTEZITNI VLNA VLEVO  -------------------------------------------------------------
;--------------------------------------------------------------------------------------------------------------------------------------

H21: LCALL LINTL ;VLNA VLEVO 				;VLNAVLEVO	
	LJMP H24

H23: LCALL LZINTL	;ZHASENI VLEVO 				;NVLNAVLEVO	
	LJMP H10
;------------------------------------TIMER 1 = 50 x 0,1 SEC = 5 SEC --------------------------
H24:	MOV R0,#100D		;100 x 0,1SEC=TIMER2=10SEC
H25:	LCALL T100MS
	LCALL UC2
	MOV A,052H
	CJNE A,#000H,H23  	;PREDMET JE PRITOMEN
	DJNZ R0,H25
;-----------------------------------TIMER 2 = 250 x 4 x 0,1 SEC = 2 MINUTY CCA I SE ZHASNUTIM --------------------------
	MOV R0,#250D
H26:	LCALL T100MS
	;LCALL UC2
	;MOV A,052H
	;CJNE A,#000H,H23  	;PREDMET JE PRITOMEN
	DJNZ R0,H26
;-----------------------------------
	MOV R0,#250D
H27:	LCALL T100MS
	;LCALL UC2
	;MOV A,052H
	;CJNE A,#000H,H23  	;PREDMET JE PRITOMEN
	DJNZ R0,H27
;-----------------------------------
	MOV R0,#250D
H28:	LCALL T100MS
	;LCALL UC2
	;MOV A,052H
	;CJNE A,#000H,H23  	;PREDMET JE PRITOMEN
	DJNZ R0,H28
;-----------------------------------
	MOV R0,#250D
H29:	LCALL T100MS
	;LCALL UC2
	;MOV A,052H
	;CJNE A,#000H,H23  	;PREDMET JE PRITOMEN
	DJNZ R0,H29
;-----------------------------------
	LCALL ZHASINANI		; ZHASNUTI ZA 15 SEC JAKO V KINE 
	LJMP H10


;########################################################### KONEC HLAVNIHO PROGRAMU #########################################################

;===============================VLNA VPRAVO  SKOKOVA ============================================

VLNAVPRAVO:
	CALL CITACVPRAVO
	MOV P0,030H				;PRO SOUCET
	MOV P2,031H				;PRO SOUCET
;-----------------------
	MOV A,032H				;SOUCET
	ORL P0,A				;SOUCET
;-----------------------
	MOV A,033H				;SOUCET
	ORL P2,A				;SOUCET
;----------------------
	LCALL T100MS	;LCALL TSCH	;##################################################
	INC R0
	;INC R1

	CJNE R0,#010H,VLNAVPRAVO			;COMPARE  R0 s DATA = 33H  AND JUMP IF NOT EGUAL
	MOV 030H,#000H
	MOV 031H,#000H
	MOV R0,#000H	; CITAC NAHORU------------------------------------------

	RET
;=============================== VYPINACI VLNA VPRAVO SKOKOVA ============================================

NVLNAVPRAVO:
	CALL NCITACVPRAVO
	MOV P0,030H				;PRO SOUCET
	MOV P2,031H				;PRO SOUCET
;-----------------------
	MOV A,032H				;SOUCET
	ORL P0,A				;SOUCET
;-----------------------
	MOV A,033H				;SOUCET
	ORL P2,A				;SOUCET
;----------------------
	LCALL T100MS	;LCALL TSCH	;##################################################
	INC R0
	;INC R1

	CJNE R0,#010H,NVLNAVPRAVO			;COMPARE  R0 s DATA = 33H  AND JUMP IF NOT EGUAL
	MOV 030H,#000H
	MOV 031H,#000H
	MOV R0,#000H	; CITAC NAHORU------------------------------------------

	RET
;=============================VLNA VLEVO SKOKOVA ================================================
VLNAVLEVO:						
	CALL CITACVLEVO
	MOV P0,030H				;PRO SOUCET
	MOV P2,031H				;PRO SOUCET
;-----------------------
	MOV A,032H				;SOUCET
	ORL P0,A				;SOUCET
;-----------------------
	MOV A,033H				;SOUCET
	ORL P2,A				;SOUCET
;----------------------
	LCALL T100MS	;LCALL TSCH	;######################################################
	;INC R0
	INC R1

	CJNE R1,#010H,VLNAVLEVO			;COMPARE  R0 s DATA = 33H  AND JUMP IF NOT EGUAL
	MOV 032H,#000H
	MOV 033H,#000H
	MOV R1,#000H	; CITAC NAHORU------------------------------------------

	RET

;=============================VYPINACI VLNA VLEVO SKOKOVA ================================================
NVLNAVLEVO:						
	CALL NCITACVLEVO
	MOV P0,030H				;PRO SOUCET
	MOV P2,031H				;PRO SOUCET
;-----------------------
	MOV A,032H				;SOUCET
	ORL P0,A				;SOUCET
;-----------------------
	MOV A,033H				;SOUCET
	ORL P2,A				;SOUCET
;----------------------
	LCALL T100MS	;LCALL TSCH	;######################################################
	;INC R0
	INC R1

	CJNE R1,#010H,NVLNAVLEVO			;COMPARE  R0 s DATA = 33H  AND JUMP IF NOT EGUAL
	MOV 032H,#000H
	MOV 033H,#000H
	MOV R1,#000H	; CITAC NAHORU------------------------------------------

	RET

;---------------------TEST FOTONKY------------------------------------------------------
H200:	JB FOTONKA,H201
	CLR SH3
	JNB DIP6,H200

	RET

H201:  SETB SH3
	JNB DIP6,H200

	RET

;############################################## SKOKOVE POJETI ##########################################################################

CITACVPRAVO:	 ;R0-CITAC VPRAVO 1-16 PRO ZAPINANI 
	MOV DPTR, #TAB1
	MOV A,R0
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 030H,A
 
	MOV DPTR, #TAB2
	MOV A,R0
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 031H,A

	RET

;--------------------------------------------------------------------------------------

CITACVLEVO:	 ;R1-CITAC VPRAVO 1-16 PRO ZAPINANI 
	MOV DPTR, #TAB2
	MOV A,R1
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 032H,A
 
	MOV DPTR, #TAB1
	MOV A,R1
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 033H,A

	RET

;################################################### SKOKOVE POJETI #####################################################################

NCITACVPRAVO:	 ;R0-CITAC VPRAVO 1-16 PRO VYPINANI 
	MOV DPTR, #TAB3
	MOV A,R0
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 030H,A
 
	MOV DPTR, #TAB4
	MOV A,R0
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 031H,A

	RET

;--------------------------------------------------------------------------------------

NCITACVLEVO:	 ;R1-CITAC VPRAVO 1-16 PRO VYPINANI 
	MOV DPTR, #TAB4
	MOV A,R1
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 032H,A
 
	MOV DPTR, #TAB3
	MOV A,R1
	MOVC A,@A+DPTR		;M(INT)(ADRESA A+DPTR)>>>A.....DPTR UKAZTEL DAT
	MOV 033H,A

	RET

;========================================================================================================================================
;========================================================================================================================================
	
;-------------------------------------------------PODPROGRAMY---------------------------------

;------------------------------ TIME IMTERVAL  R40 - R41 ------------
Tmin: MOV 040H,#0AAH		;DELTA 1/1S
Tm2:	MOV 041H,#0FFH
Tm1:	DJNZ 041H,Tm1 
	DJNZ 040H,Tm2
	RET

	;JNB TLxx,Tmxx..............PRERUSENI
	


;-------------------------------- TIME INTERVAL 100ms R42 -----------
T100ms:
	MOV 042H,#00AH
	LCALL Tmin
TA:	
	;SEM UMISTITI ULTRAZVUKOVE PRERUSENI 
	DJNZ 042H,TA
	RET

;-------------------------------- TIME INTERVAL 5s R43----------------
T5S:
	MOV 043H,#032H
TB:	LCALL T100MS
	DJNZ 043H,TB
	RET
;-------------------------------- TIME INTERVAL 1s R43----------------
T1S:
	MOV 043H,#00AH
TC:	LCALL T100MS

	DJNZ 043H,TC
	RET
;-------------------------------- TIME INTERVAL 10MIKROS ---------
T10MIKROS:

	NOP

	RET
;-----------------------------TAU = TT -----------------------------------
TT: 	LCALL T1S
	RET
;================================================================================================================================

;-----------------------------CASOVANI PRO ULTRAZVUK PARAMETR DIP 5,6,7,8= M48----------------------------------
	;DIP1		EQU		P3.0		;VZDALENOST REAKCE 0-70		
	;DIP2		EQU		P3.1		;VZDALENOST REAKCE 0-80		
	;DIP3		EQU		P3.2		;VZDALENOST REAKCE 0-90		
	;DIP4		EQU		P3.3		;VZDALENOST REAKCE 0-100	
							;		 JINAK 0-110
TOUT:	
	JB DIP1,TOUT1	;PARAMETR DLE DIP 
	MOV 048H,#007D
	JMP TOUT6

TOUT1:JB DIP2,TOUT2	;PARAMETR DLE DIP 
	MOV 048H,#008D
	JMP TOUT6

TOUT2:JB DIP3,TOUT3	;PARAMETR DLE DIP 
	MOV 048H,#009D
	JMP TOUT6

TOUT3:JB DIP4,TOUT4	;PARAMETR DLE DIP 
	MOV 048H,#010D
	JMP TOUT6

TOUT4:MOV 048H,#011D	;PARAMETR DLE DIP 

TOUT6:RET


;===========================================================================================================================



;========================================TEST PRITOMNOSTI PREDMET OD CIDLA 2======================
TESTCIDLA2:
K4:	LCALL TOUT		;VOLBA DIPEM 1234

	SETB TRIG2		;POVONNE
	LCALL T10MIKROS	;POVONNE
	LCALL T10MIKROS	;POVINNE
	LCALL T10MIKROS	;POVINNE
	CLR TRIG2		;POVONNE
	
	JNB OUT2,$
	;TAU/SELEKTOR   CIM DELSI TIM VETSI VZDALENOST
	LCALL TX70CM

	JNB OUT2,K5		;PRITOMNY PREDMET
	CLR SH3		;NEPRITOMNY PREDMET
	JMP K4

K5:   SETB SH3
	JMP K4
;====================================MERIDLO DELKY TX10CM==========================
TX10CM:
	MOV R5,#075D	;185D-0AZ 23CM	100D-0 AZ 13 CM	75D- 0 AZ 10CM
TX1:	LCALL T10MIKROS	;POVONNE
	DJNZ R5,TX1
	RET
;==================================MERIDLO 0 AZ 70 CM =============================
TX70CM:
	MOV R6,#007D
TX71:	LCALL TX10CM
	DJNZ R6,TX71
	RET
;==================================================================================
;==================================MERIDLO 0 AZ 80 CM =============================
TX80CM:
	MOV R6,#008D
TX81:	LCALL TX10CM
	DJNZ R6,TX81
	RET
;==================================================================================
;==================================MERIDLO 0 AZ 90 CM =============================
TX90CM:
	MOV R6,#009D
TX91:	LCALL TX10CM
	DJNZ R6,TX91
	RET
;==================================================================================
;==================================MERIDLO 0 AZ 100 CM ============================
TX100CM:
	MOV R6,#010D
TX101:LCALL TX10CM
	DJNZ R6,TX101
	RET
;==================================================================================
;==================================MERIDLO 0 AZ 100 CM ============================
TX110CM:
	MOV R6,#011D
TX111:LCALL TX10CM
	DJNZ R6,TX111
	RET
;=====================================================SPUSTENI OD CIDLA2======================================================================
UC2:		; SPUSTENI OD CIDLA2............M52=80= PREDMET PROTOMEN,,,,,M52=00=PREDMET NENI
	LCALL TOUT		;VOLBA DIPEM 1234
	SETB TRIG2		;POVONNE	TRIG2/1
	LCALL T10MIKROS	;POVONNE
	LCALL T10MIKROS	;POVINNE
	LCALL T10MIKROS	;POVINNE
	CLR TRIG2		;POVONNE	TRIG2/1

	JNB OUT2,$				;OUT2/1
	;TAU/SELEKTOR   CIM DELSI TIM VETSI VZDALENOST
UC21:LCALL TX10CM
	DJNZ 048H,UC21
	
	JNB OUT2,UC22	;STRAT DO CIDLA 2 M52= 80H	;OUT2/1
	MOV 052H,#000H
	RET

UC22:MOV 052H,#080H
	RET
;======================================================SPUSTENI OD CIDLA1=====================================================================
		; SPUSTENI OD CIDLA2............M52=80= PREDMET PROTOMEN,,,,,M52=00=PREDMET NENI
UC1:		; SPUSTENI OD CIDLA2............M52=80= PREDMET PROTOMEN,,,,,M52=00=PREDMET NENI
	LCALL TOUT		;VOLBA DIPEM 1234
	SETB TRIG1		;POVONNE	TRIG2/1
	LCALL T10MIKROS	;POVONNE
	LCALL T10MIKROS	;POVINNE
	LCALL T10MIKROS	;POVINNE
	CLR TRIG1		;POVONNE	TRIG2/1

	JNB OUT1,$				;OUT2/1
	;TAU/SELEKTOR   CIM DELSI TIM VETSI VZDALENOST
UC11:LCALL TX10CM
	DJNZ 048H,UC11
	
	JNB OUT1,UC12	;STRAT DO CIDLA 2 M52= 80H	;OUT2/1
	MOV 052H,#000H
	RET

UC12:MOV 052H,#080H
	RET
;==================================== ZHASINANI 15 SEC===================================
ZHASINANI:
	CLR C				;CY=0
	MOV R7,#0FFH

ZH0:	
	MOV R5,#060H		;80H=15SEC , 40H=8SEC
ZH01: MOV P2,#0FFH
	MOV P0,#0FFH

	LCALL ZHP
	MOV P2,#000H
	MOV P0,#000H

	LCALL ZHM
	MOV P2,#0FFH
	MOV P0,#0FFH

	DJNZ R5,ZH01
	DJNZ R7,ZH0

      MOV R3,#025H		;MINIMALNI SVIT CCA 4SEC
ZH03:	MOV R4,#0FFH
ZH02:
	
	MOV P2,#000H
	MOV P0,#000H

	MOV R7,#0FFH
	DJNZ R7,$

	MOV P2,#0FFH
	MOV P0,#0FFH

	MOV R7,#001H
	DJNZ R7,$

	DJNZ R4,ZH02
	DJNZ R3,ZH03


	MOV P2,#000H
	MOV P0,#000H
	RET			;ukonceni#####################################
;---------------------------------------------------------------


ZHP:	MOV A,R7
	MOV R6,A
	DJNZ R6,$
	RET
;----------------------------------------------------------------
ZHM:	MOV A,#0FFH
	SUBB A,R7			;A=A-R7-CY
	MOV R6,A
	DJNZ R6,$
	RET
;-------------------------------------------vlna intenzity vpravo --------------------------------------------------------------
INTR: 
	JNB DIP7,X21
	JNB DIP8,X22
	MOV 065H,#001H		;DOBA SVITU	3S
	JMP X23
X21:	MOV 065H,#002H		;DOBA SVITU	5S
	JMP X23
X22:	MOV 065H,#003H		;DOBA SVITU	7S

X23:	MOV 064H,#001H	

I11:	MOV R4,065H	 
I12:	CLR SH1			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH1			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I12
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I11
;------------------------------------------------------------
	MOV 064H,#001H	
I21:	MOV R4,065H	 		;DOBA SVITU 
I22:	CLR SH2			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH2			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I22
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I21
;------------------------------------------------------------
	MOV 064H,#001H	
I31:	MOV R4,065H	 	;DOBA SVITU 
I32:	CLR SH3			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH3			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I32
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I31
;------------------------------------------------------------
	MOV 064H,#001H	
I41:	MOV R4,065H	 	;DOBA SVITU 
I42:	CLR SH4			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH4			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I42
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I41
;------------------------------------------------------------
	MOV 064H,#001H	
I51:	MOV R4,065H	 	;DOBA SVITU 
I52:	CLR SH5			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH5			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I52
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I51
;------------------------------------------------------------
	MOV 064H,#001H	
I61:	MOV R4,065H	 	;DOBA SVITU 
I62:	CLR SH6			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH6			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I62
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I61
;------------------------------------------------------------
	MOV 064H,#001H	
I71:	MOV R4,065H	 	;DOBA SVITU 
I72:	CLR SH7			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH7			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I72
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I71
;------------------------------------------------------------
	MOV 064H,#001H	
I81:	MOV R4,065H	 	;DOBA SVITU 
I82:	CLR SH8			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH8			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I82
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I81
;===============================================================================================================
	MOV 064H,#001H	
I91:	MOV R4,065H	 
I92:	CLR SH9			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH9			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,I92
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,I91
;------------------------------------------------------------
	MOV 064H,#001H	
IA1:	MOV R4,065H	 		;DOBA SVITU 
IA2:	CLR SH10			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH10			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,IA2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,IA1
;------------------------------------------------------------
	MOV 064H,#001H	
IB1:	MOV R4,065H	 	;DOBA SVITU 
IB2:	CLR SH11			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH11			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,IB2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,IB1
;------------------------------------------------------------
	MOV 064H,#001H	
IC1:	MOV R4,065H	 	;DOBA SVITU 
IC2:	CLR SH12			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH12			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,IC2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,IC1
;------------------------------------------------------------
	MOV 064H,#001H	
ID1:	MOV R4,065H	 	;DOBA SVITU 
ID2:	CLR SH13			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH13			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ID2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ID1
;------------------------------------------------------------
	MOV 064H,#001H	
IH1:	MOV R4,065H	 	;DOBA SVITU 
IH2:	CLR SH14			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH14			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,IH2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,IH1
;------------------------------------------------------------
	MOV 064H,#001H	
IF1:	MOV R4,065H	 	;DOBA SVITU 
IF2:	CLR SH15			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH15			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,IF2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,IF1
;------------------------------------------------------------
	MOV 064H,#001H	
IG1:	MOV R4,065H	 	;DOBA SVITU 
IG2:	CLR SH16			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH16			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,IG2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,IG1
;===============================================================================================================

	RET			;ukonceni#####################################
;------------------------------------------------------------------------------------------------------------------
;-------------------------------------------ZHASECI vlna intenzity vpravo --------------------------------------------------------------
ZINTR: 

	JNB DIP7,X31
	JNB DIP8,X32
	MOV 065H,#001H		;DOBA SVITU	3S
	JMP X33
X31:	MOV 065H,#002H		;DOBA SVITU	5S
	JMP X33
X32:	MOV 065H,#003H		;DOBA SVITU	7S

X33:	MOV 064H,#001H
	
ZI11:	MOV R4,065H	 
ZI12:	SETB SH1			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH1			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI12
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI11
;------------------------------------------------------------
	MOV 064H,#001H	
ZI21:	MOV R4,065H	 		;DOBA SVITU 
ZI22:	SETB SH2			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH2			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI22
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI21
;------------------------------------------------------------
	MOV 064H,#001H	
ZI31:	MOV R4,065H	 	;DOBA SVITU 
ZI32:	SETB SH3			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH3			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI32
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI31
;------------------------------------------------------------
	MOV 064H,#001H	
ZI41:	MOV R4,065H	 	;DOBA SVITU 
ZI42:	SETB SH4			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH4			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI42
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI41
;------------------------------------------------------------
	MOV 064H,#001H	
ZI51:	MOV R4,065H	 	;DOBA SVITU 
ZI52:	SETB SH5			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH5			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI52
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI51
;------------------------------------------------------------
	MOV 064H,#001H	
ZI61:	MOV R4,065H	 	;DOBA SVITU 
ZI62:	SETB SH6			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH6			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI62
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI61
;------------------------------------------------------------
	MOV 064H,#001H	
ZI71:	MOV R4,065H	 	;DOBA SVITU 
ZI72:	SETB SH7			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH7			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI72
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI71
;------------------------------------------------------------
	MOV 064H,#001H	
ZI81:	MOV R4,065H	 	;DOBA SVITU 
ZI82:	SETB SH8			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH8			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI82
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI81
;===============================================================================================================
	MOV 064H,#001H	
ZI91:	MOV R4,065H	 
ZI92:	SETB SH9			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH9			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZI92
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZI91
;------------------------------------------------------------
	MOV 064H,#001H	
ZIA1:	MOV R4,065H	 		;DOBA SVITU 
ZIA2:	SETB SH10			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH10			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZIA2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZIA1
;------------------------------------------------------------
	MOV 064H,#001H	
ZIB1:	MOV R4,065H	 	;DOBA SVITU 
ZIB2:	SETB SH11			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH11			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZIB2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZIB1
;------------------------------------------------------------
	MOV 064H,#001H	
ZIC1:	MOV R4,065H	 	;DOBA SVITU 
ZIC2:	SETB SH12			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH12			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZIC2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZIC1
;------------------------------------------------------------
	MOV 064H,#001H	
ZID1:	MOV R4,065H	 	;DOBA SVITU 
ZID2:	SETB SH13			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH13			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZID2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZID1
;------------------------------------------------------------
	MOV 064H,#001H	
ZIH1:	MOV R4,065H	 	;DOBA SVITU 
ZIH2:	SETB SH14			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH14			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZIH2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZIH1
;------------------------------------------------------------
	MOV 064H,#001H	
ZIF1:	MOV R4,065H	 	;DOBA SVITU 
ZIF2:	SETB SH15			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH15			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZIF2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZIF1
;------------------------------------------------------------
	MOV 064H,#001H	
ZIG1:	MOV R4,065H	 	;DOBA SVITU 
ZIG2:	SETB SH16			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH16			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,ZIG2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,ZIG1
;===============================================================================================================		
	RET
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;-------------------------------------------vlna intenzity VLEVO --------------------------------------------------------------
LINTL: 

	JNB DIP7,X1
	JNB DIP8,X2
	MOV 065H,#001H		;DOBA SVITU	3S
	JMP X3
X1:	MOV 065H,#002H		;DOBA SVITU	5S
	JMP X3
X2:	MOV 065H,#003H		;DOBA SVITU	7S

X3:	MOV 064H,#001H	

LI11:	MOV R4,065H	 
LI12:	CLR SH16			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH16			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI12
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI11
;------------------------------------------------------------
	MOV 064H,#001H	
LI21:	MOV R4,065H	 		;DOBA SVITU 
LI22:	CLR SH15			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH15			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI22
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI21
;------------------------------------------------------------
	MOV 064H,#001H	
LI31:	MOV R4,065H	 	;DOBA SVITU 
LI32:	CLR SH14			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH14			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI32
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI31
;------------------------------------------------------------
	MOV 064H,#001H	
LI41:	MOV R4,065H	 	;DOBA SVITU 
LI42:	CLR SH13			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH13			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI42
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI41
;------------------------------------------------------------
	MOV 064H,#001H	
LI51:	MOV R4,065H	 	;DOBA SVITU 
LI52:	CLR SH12			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH12			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI52
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI51
;------------------------------------------------------------
	MOV 064H,#001H	
LI61:	MOV R4,065H	 	;DOBA SVITU 
LI62:	CLR SH11			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH11			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI62
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI61
;------------------------------------------------------------
	MOV 064H,#001H	
LI71:	MOV R4,065H	 	;DOBA SVITU 
LI72:	CLR SH10			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH10			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI72
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI71
;------------------------------------------------------------
	MOV 064H,#001H	
LI81:	MOV R4,065H	 	;DOBA SVITU 
LI82:	CLR SH9			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH9			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI82
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI81
;===============================================================================================================
	MOV 064H,#001H	
LI91:	MOV R4,065H	 
LI92:	CLR SH8			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH8			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LI92
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LI91
;------------------------------------------------------------
	MOV 064H,#001H	
LIA1:	MOV R4,065H	 		;DOBA SVITU 
LIA2:	CLR SH7			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH7			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LIA2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LIA1
;------------------------------------------------------------
	MOV 064H,#001H	
LIB1:	MOV R4,065H	 	;DOBA SVITU 
LIB2:	CLR SH6			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH6			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LIB2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LIB1
;------------------------------------------------------------
	MOV 064H,#001H	
LIC1:	MOV R4,065H	 	;DOBA SVITU 
LIC2:	CLR SH5			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH5			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LIC2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LIC1
;------------------------------------------------------------
	MOV 064H,#001H	
LID1:	MOV R4,065H	 	;DOBA SVITU 
LID2:	CLR SH4			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH4			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LID2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LID1
;------------------------------------------------------------
	MOV 064H,#001H	
LIH1:	MOV R4,065H	 	;DOBA SVITU 
LIH2:	CLR SH3			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH3			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LIH2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LIH1
;------------------------------------------------------------
	MOV 064H,#001H	
LIF1:	MOV R4,065H	 	;DOBA SVITU 
LIF2:	CLR SH2			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH2			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LIF2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LIF1
;------------------------------------------------------------
	MOV 064H,#001H	
LIG1:	MOV R4,065H	 	;DOBA SVITU 
LIG2:	CLR SH1			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	SETB SH1			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LIG2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LIG1
;===============================================================================================================

	RET			;ukonceni#####################################
;------------------------------------------------------------------------------------------------------------------
;-------------------------------------------ZHASECI vlna intenzity VLEVO --------------------------------------------------------------
LZINTL: 
	JNB DIP7,X11
	JNB DIP8,X12
	MOV 065H,#001H		;DOBA SVITU	3S
	JMP X13
X11:	MOV 065H,#002H		;DOBA SVITU	5S
	JMP X13
X12:	MOV 065H,#003H		;DOBA SVITU	7S

X13:	MOV 064H,#001H	


LZI11:	MOV R4,065H	 
LZI12:	SETB SH16			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH16			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI12
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI11
;------------------------------------------------------------
	MOV 064H,#001H	
LZI21:	MOV R4,065H	 		;DOBA SVITU 
LZI22:	SETB SH15			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH15			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI22
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI21
;------------------------------------------------------------
	MOV 064H,#001H	
LZI31:	MOV R4,065H	 	;DOBA SVITU 
LZI32:	SETB SH14			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH14			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI32
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI31
;------------------------------------------------------------
	MOV 064H,#001H	
LZI41:	MOV R4,065H	 	;DOBA SVITU 
LZI42:	SETB SH13			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH13			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI42
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI41
;------------------------------------------------------------
	MOV 064H,#001H	
LZI51:	MOV R4,065H	 	;DOBA SVITU 
LZI52:	SETB SH12			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH12			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI52
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI51
;------------------------------------------------------------
	MOV 064H,#001H	
LZI61:	MOV R4,065H	 	;DOBA SVITU 
LZI62:	SETB SH11			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH11			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI62
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI61
;------------------------------------------------------------
	MOV 064H,#001H	
LZI71:	MOV R4,065H	 	;DOBA SVITU 
LZI72:	SETB SH10			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH10			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI72
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI71
;------------------------------------------------------------
	MOV 064H,#001H	
LZI81:	MOV R4,065H	 	;DOBA SVITU 
LZI82:	SETB SH9			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH9			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI82
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI81
;===============================================================================================================
	MOV 064H,#001H	
LZI91:	MOV R4,065H	 
LZI92:	SETB SH8			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH8			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZI92
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZI91
;------------------------------------------------------------
	MOV 064H,#001H	
LZIA1:	MOV R4,065H	 		;DOBA SVITU 
LZIA2:	SETB SH7			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH7			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZIA2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZIA1
;------------------------------------------------------------
	MOV 064H,#001H	
LZIB1:	MOV R4,065H	 	;DOBA SVITU 
LZIB2:	SETB SH6			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH6			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZIB2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZIB1
;------------------------------------------------------------
	MOV 064H,#001H	
LZIC1:	MOV R4,065H	 	;DOBA SVITU 
LZIC2:	SETB SH5			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH5			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZIC2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZIC1
;------------------------------------------------------------
	MOV 064H,#001H	
LZID1:	MOV R4,065H	 	;DOBA SVITU 
LZID2:	SETB SH4			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH4			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZID2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZID1
;------------------------------------------------------------
	MOV 064H,#001H	
LZIH1:	MOV R4,065H	 	;DOBA SVITU 
LZIH2:	SETB SH3			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH3			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZIH2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZIH1
;------------------------------------------------------------
	MOV 064H,#001H	
LZIF1:	MOV R4,065H	 	;DOBA SVITU 
LZIF2:	SETB SH2			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH2			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZIF2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZIF1
;------------------------------------------------------------
	MOV 064H,#001H	
LZIG1:	MOV R4,065H	 	;DOBA SVITU 
LZIG2:	SETB SH1			;SH1			
	MOV A,#0FFH
	SUBB A,064H
	MOV R7,A
	DJNZ R7,$
	CLR SH1			;SH1		
	MOV R7,064H		;INTENZITA SVITU
	DJNZ R7,$
	DJNZ R4,LZIG2
	INC 064H
	MOV A,064H
	CJNE A,#0FFH,LZIG1
;===============================================================================================================		
	RET

;=========================================================================================================II============================================================================================================
TAB1:	DB	00000001B , 00000011B , 00000111B , 00001111B , 00011111B , 00111111B , 01111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B ,00000000B ,
TAB2:	DB	00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 10000000B , 11000000B , 11100000B , 11110000B , 11111000B , 11111100B , 11111110B , 11111111B ,00000000B ,
;=======================================================================================================================================================================================================================

;=========================================================================================================II============================================================================================================
TAB3:	DB	11111110B , 11111100B , 11111000B , 11110000B , 11100000B , 11000000B , 10000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B , 00000000B ,00000000B ,
TAB4:	DB	11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 11111111B , 01111111B , 00111111B , 00011111B , 00001111B , 00000111B , 00000011B , 00000001B , 00000000B ,00000000B ,
;=======================================================================================================================================================================================================================
	END
	

